#include <iostream>
#include <fstream>
#include <string>
using namespace std;

int done(double res, const string & msg) {
	cout << res << '\n';
	cerr << msg << '\n';
	return 0;
}

int main (int argc, char **argv) {
	ifstream input_file(argv[1]);
	ifstream answer_file(argv[2]);
	ifstream student_file(argv[3]);

	string answer;
	answer_file >> answer;

	string student;
	if (!(student_file >> student)) {
		return done(0, "No output");
	}
	for (auto c : student) {
		if (c < 'a' || c > 'z') {
			return done(0, "Invalid characters");
		}
	}
	string dummy;
	if (student_file >> dummy) {
		return done(0, "Extra output");
	}

	int n;
	input_file >> n;
	for (int i = 0; i < n; ++i) {
		string s;
		input_file >> s;
		if (student.find(s) == string::npos) {
			return done(0, "Wrong answer");
		}
	}

	return done(double(answer.length()) / double(student.length()), "OK");
}
