/* oliveri petrozavodski lahendus */
#include <bits/stdc++.h>
using namespace std;

#define ran(i,a,b) for(auto i = (a); i < (b); i++)

typedef long long ll;

ifstream fi("rvsis.txt");
ofstream fo("rvval.txt");

int n;
vector<bool> vis;
vector<bool> act;
vector<int> col;
vector<int> cur_size;
vector<vector<int> > con;
vector<int> x, y;

bool try_col(int x){
	bool col_use[5]{};
	for(auto nxt : con[x]){
		if(act[nxt]){
			col_use[col[nxt]] = true;
		}
	}
	ran(i,1,5){
		if(!col_use[i]){
			col[x] = i;
			return true;
		}
	}
	return false;
}

void dfsrecol(int cur, int a, int b){
	if(col[cur] == a){
		col[cur] = b;
	} else {
		col[cur] = a;
	}
	for(int nxt : con[cur]){
		if(!vis[nxt] && (col[nxt]==a || col[nxt] == b)){
			vis[nxt] = true;
			dfsrecol(nxt, a, b);
		}
	}
}

int main () {
	int m;
	fi>>n>>m;
	act.resize(n, true);
	col.resize(n);
	cur_size.resize(n);
	con.resize(n);
	x.resize(n);
	y.resize(n);
	vector<int> rem;
	ran(i,0,n){
		fi>>x[i]>>y[i];
	}
	ran(i,0,m){
		int u, v;
		fi>>u>>v;
		--u;
		--v;
		con[u].push_back(v);
		con[v].push_back(u);
		++cur_size[u];
		++cur_size[v];
	}
	while(rem.size() <n){
		bool found = false;
		ran(j,0,n){
			if(act[j] && cur_size[j] <= 3){
				rem.push_back(j);
				act[j] = false;
				for(auto nxt : con[j]){
					cur_size[nxt]--;
				}
				found = true;
			}
		}
		if(!found){
			ran(j,0,n){
				if(act[j] && cur_size[j] == 4){
					rem.push_back(j);
					act[j] = false;
					for(auto nxt : con[j]){
						cur_size[nxt]--;
					}
					break;
				}
			}
		}
	}
	while(!rem.empty()){
		int cur = rem.back();
		rem.pop_back();
		if(!try_col(cur)){
			vis = vector<bool>(n);
			vector<pair<double, int> > ord;
			for(auto nxt : con[cur]){
				if(act[nxt]){
					ord.emplace_back(atan2(x[nxt]-x[cur], y[nxt]-y[cur]), nxt);
				}
			}
			sort(ord.begin(), ord.end());
			vis[ord[0].second] = true;
			dfsrecol(ord[0].second, col[ord[0].second], col[ord[2].second]);
			if(!try_col(cur)){
				vis[ord[1].second] = true;
				dfsrecol(ord[1].second, col[ord[1].second], col[ord[3].second]);
				try_col(cur);
			}
		}
		act[cur] = true;
		for(auto nxt : con[cur]){
			cur_size[nxt]++;
		}
	}
	for(int i=0; i<n; ++i){
		fo<<col[i]<<'\n';
	}
}
