/* lihtne iteratiivne algoritm. kasutab ülimalt 9 värvi */
#include <fstream>
#include <vector>
using namespace std;

ifstream fi("rvsis.txt");
ofstream fo("rvval.txt");

const int maxn = 10005;

int colors [maxn];
bool used [11];
vector<int> adj [maxn];

int main () {
  int vertexc, edgec;
  fi >> vertexc >> edgec;

  for (int i = 0; i < vertexc; i++) {
    int x, y;
    fi >> x >> y;
  }

  for (int i = 0; i < edgec; i++) {
    int u, v;
    fi >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  for (int i = 1; i <= vertexc; i++) {
    for (int k = 1; k <= 10; k++) {
      used[k] = 0;
    }

    for (int nxt : adj[i]) {
      used[colors[nxt]] = 1;
    }

    int color = -1;
    for (int k = 1; k <= 10; k++) {
      if (!used[k]) {
        color = k;
        break;
      }
    }

    colors[i] = color;
    fo << color << '\n';
  }
}
