#include <fstream>
#include <string>
#include <vector>
using namespace std;

typedef long long ll;

int Diff(const string& x, const string& y) {
    for (int i = 0; i < min(x.size(), y.size()); ++i) {
        if (x[i] != y[i]) {
            return x.size() - i + y.size() - i;
        }
    }
    return max(x.size(), y.size()) - min(x.size(), y.size());
}

ll Solve(const vector<string>& a) {
    ll res = 0;
    for (auto x : a) {
        for (auto y : a) {
            res += Diff(x, y);
        }
    }
    return res;
}

int main() {
    ifstream fi("tesis.txt");
    ofstream fo("teval.txt");

    int n;
    fi >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        fi >> a[i];
    }
    fo << Solve(a) << '\n';
    return 0;
}
