/* targas järjekorras läbiv iteratiivne algoritm. kasutab ülimalt 5 värvi */
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fi("rvsis.txt");
ofstream fo("rvval.txt");

const int maxn = 10005;

int colors [maxn];
bool used [11];
vector<int> adj [maxn];

int main () {
  int vertexc, edgec;
  fi >> vertexc >> edgec;

  vector<pair<pair<int, int>, int>> ord;
  for (int i = 1; i <= vertexc; i++) {
    int x, y;
    fi >> x >> y;
    ord.push_back(make_pair(make_pair(x, y), i));
  }


  for (int i = 0; i < edgec; i++) {
    int u, v;
    fi >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  sort(ord.begin(), ord.end());

  for (pair<pair<int, int>, int> pr : ord) {
    int i = pr.second;
    for (int k = 1; k <= 10; k++) {
      used[k] = 0;
    }

    for (int nxt : adj[i]) {
      used[colors[nxt]] = 1;
    }

    int color = -1;
    for (int k = 1; k <= 10; k++) {
      if (!used[k]) {
        color = k;
        break;
      }
    }

    colors[i] = color;
  }

  for (int i = 1; i <= vertexc; i++) {
    fo << colors[i] << '\n';
  }
}
